# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`git`](#git): Sets up requirements for git

### Defined types

* [`git::repo`](#gitrepo): Check out a git repository

## Classes

### <a name="git"></a>`git`

Sets up requirements for git

* **See also**
  * git::repo
    * on how to use this module.

#### Examples

##### Override the git version

```puppet
class { 'git':
  package_ensure => '2.1.0',
}
```

#### Parameters

The following parameters are available in the `git` class:

* [`bin`](#bin)
* [`package`](#package)
* [`package_ensure`](#package_ensure)

##### <a name="bin"></a>`bin`

Data type: `Any`

The path to the git binary

Default value: ``undef``

##### <a name="package"></a>`package`

Data type: `Any`

Override the name of the git package(s) to include.

Default value: ``undef``

##### <a name="package_ensure"></a>`package_ensure`

Data type: `Any`

Override the git package ensure

Default value: ``undef``

## Defined types

### <a name="gitrepo"></a>`git::repo`

Check out a git repository

#### Examples

##### Clone a git repository

```puppet
git::repo {'mygit':
  target => '/home/user/puppet-git',
  source => 'https://github.com/theforeman/puppet-git.git',
  user   => 'user',
}
```

#### Parameters

The following parameters are available in the `git::repo` defined type:

* [`target`](#target)
* [`bare`](#bare)
* [`source`](#source)
* [`user`](#user)
* [`group`](#group)
* [`mode`](#mode)
* [`workdir`](#workdir)
* [`args`](#args)
* [`timeout`](#timeout)
* [`bin`](#bin)

##### <a name="target"></a>`target`

Data type: `String`

Target folder

##### <a name="bare"></a>`bare`

Data type: `Boolean`

Create a bare repository

Default value: ``false``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

Source to clone from. If not specified, no remote will be used.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String`

Owner of the repository

Default value: `'root'`

##### <a name="group"></a>`group`

Data type: `String`

Group of the repository

Default value: `'root'`

##### <a name="mode"></a>`mode`

Data type: `String`

Mode of the repository root

Default value: `'0755'`

##### <a name="workdir"></a>`workdir`

Data type: `Stdlib::Absolutepath`

The working directory while executing git

Default value: `'/tmp'`

##### <a name="args"></a>`args`

Data type: `Optional[String]`

Optional arguments to the git command

Default value: ``undef``

##### <a name="timeout"></a>`timeout`

Data type: `Optional[Integer]`

Optional Timeout in Seconds for the Git-Command to execute.
Puppet's "exec" defaults to 300 Seconds

Default value: ``undef``

##### <a name="bin"></a>`bin`

Data type: `String`

Git binary

Default value: `$git::bin`

